<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=0.9">
    <title>README Generation</title>
    <style>
        body {
            font-family: 'Arial', sans-serif;
            margin: 20px;
            background-color: #f4f4f4;
        }

        .container {
            display: flex;
            flex-wrap: wrap;
            justify-content: space-between;
            margin-bottom: 10px;
        }

        .column {
            width: calc(50% - 20px);
            margin-bottom: 20px;
        }

        .row {
            padding: 15px;
            border: 1px solid #ccc;
            border-radius: 5px;
            background-color: #fff;
            margin-bottom: 10px;
        }

        .form-box {
            max-width: 95%;
        }

        .form-box1 {
            max-width: 95%;
            max-height: 28%;
        }

        .form-box2 {
            max-width: 95%;
            max-height: 105%;
        }

        .form-box3 {
            max-width: 95%;
            max-height: 105%;
        }

        label {
            display: block;
            margin-bottom: 3px;
            color: #555;
            font-size: 0.8rem;
        }

        input, select, textarea {
            width: 100%;
            padding: 4px;
            margin-bottom: 8px;
            box-sizing: border-box;
            border: 1px solid #ccc;
            border-radius: 5px;
        }

        input[type="submit"] {
            background-color: #8dbe8f;
            color: white;
            cursor: pointer;
        }

        input[type="submit"]:hover {
            background-color: #3c7a3f;
        }

        .readme-content {
            border: 1px solid #ccc;
            border-radius: 5px;
            padding: 15px;
            background-color: #fff;
            overflow-y: auto;
            max-height: 500px;
        }

        .note {
            margin-top: 10px;
            color: #888;
            font-size: 0.8rem;
        }

        .rating {
            display: flex;
            flex-direction: row;
            justify-content: center;
            align-items: center;
        }

        .rating input {
            display: none;
        }

        .rating label {
            cursor: pointer;
            width: 25px;
            height: 25px;
            margin: 0 2px;
            font-size: 25px;
            line-height: 25px;
        }

        .rating label:before {
            content: '★';
        }

        .rating input:checked ~ label {
            color: #FFD700;
        }
        .button {
            background-color: #8dbe8f;
            color: white;
            border: none;
            padding: 10px 20px;
            cursor: pointer;
            border-radius: 5px;
            margin-bottom: 10px;
        }

        .button:hover {
            background-color: #3c7a3f;
        }

        .rating {
        display: flex;
        flex-direction: row;
        justify-content: center;
        align-items: center;
        direction: rtl; /* Change direction to left to right */
        }   

        .rating input[type="radio"] {
            float: left; 
            clear: none; 
        }
        .rating label {
            float: left; 
            clear: none; 
        }
        

    </style>
</head>
<body>
    <button class="button" onclick="openInstructions()">Open Instructions</button>

<div class="container">
    <div class="column">
        <div class="row form-box1">
            <h2>Clone Repository</h2>
        
            <form action="/clone" method="post">
                <label for="repository_url">Repository URL *:</label>
                <input type="text" name="repository_url" required>

                <label for="subdirectory_path">Subdirectory Path *:</label>
                <input type="text" name="subdirectory_path">

                <input type="submit" value="Clone Repository">
            </form>

            {% if message %}
                <div class="success-message">
                    <p style="font-size: 11px;">{{ message }}</p>
                </div>
            {% endif %}

            {% if requested_repo_path %}
                <div class="requested_repo_path">
                    <p style="font-size: 11px;">{{ requested_repo_path }}</p>
                </div>
            {% endif %}

        </div>

        <!-- ---------------------------------- -->

        <div class="row form-box2">
            <h2>Protobuf Files Summarizer</h2>
            <!-- Form for Protobuf files summarizer -->
            <div class="prompt-container">
                <div class="editable-box" contenteditable="true" style="color: rgb(255, 113, 137);">
                </div>
            </div>
            <form action="/summary" method="POST"> 
                <!-- Input field for user prompt -->
                <textarea name="user_prompt" rows="10" cols="50" style="overflow-y: scroll;" placeholder="
                    SAMPLE PROMPT TEMPLATE
                    ----------------------
                    
                    Please succinctly outline the step-by-step communication process for the 
                    defined Protocol Buffers service, highlighting the interaction between 
                    client and server components. Begin with the initial node, typically a 
                    databroker, and detail subsequent nodes in the communication flow.

                    (or)
         
                    Compose a concise step-by-step summary of the communication process 
                    for the defined Protocol Buffers service.
                    Provide a clear sequence of actions that occur during the communication 
                    process, emphasizing the interaction between the client and server 
                    components.

                    &quot;&quot;&quot;"></textarea>
                <br>
                <input type="submit" value="Get Summary">
            </form>
            <div class="note">
                <p>NOTE: Ensure to modify the prompt before generating the summary.</p>
            </div>
            {% if summ_message %}
                <div class="summ_message">
                    <p style="font-size: 11px;">{{ summ_message }}</p>
                </div>
            {% endif %}
        </div>

        <!-- ---------------------------------- -->

        <div class="row form-box3">
            <h2>Agent Tooling</h2>
                <!-- Form for Agent Tooling -->
                <form action="/tools" method="POST">
                    <label for="tool_name">Select a Tool:</label>
                    <select name="tool_name" id="tool_name" onchange="displayNote()">
                        <option value="">Select a Tool</option>
                        <option value="WikiAgentTool">WikiAgentTool</option>
                        <option value="UMLAgentTool">UMLAgentTool</option>
                        <option value="RepoStructureTool">RepoStructureTool</option>
                        <option value="DockerCommandsTool">DockerCommandsTool</option>
                    </select>
                    <div style="font-size: 11px;" id="note" style="display: none;"></div>
                    <input type="text" name="query" id="query">
                    <input type="submit" value="Generate Output">
                    
                    {% if tool_message %}
                    <div class="tool_message">
                        <p style="font-size: 11px;">{{ tool_message }}</p>
                    </div>
                    {% endif %}
                    
                    <script>
                        function displayNote() {
                            var selectElement = document.getElementById("tool_name");
                            var noteElement = document.getElementById("note");
                            var tool = selectElement.value;
                            var noteText = "";
                
                            switch (tool) {
                                case "WikiAgentTool":
                                    noteText = "Sample query : gRPC, Protobuf, Docker\n";
                                    break;
                                case "UMLAgentTool":
                                    noteText = "Sample query : Can you provide a description of the classes and their relationships depicted in the UML diagram generated from a repository? \
                                    I'm particularly interested in understanding the inheritance relationships between classes, any associations or dependencies, as well as any notable patterns or structures present in the diagram.\n";
                                    break;
                                case "RepoStructureTool":
                                    noteText = "Sample query : Explain and list in detail all the project dependencies and libraries.\n";
                                    break;
                                case "DockerCommandsTool":
                                    noteText = "Sample query : Based on the contents of the Dockerfile, provide docker commands to build and run the iamges for each of the files.\n";
                                    break;
                                default:
                                    noteText = "";
                            }
                
                            noteElement.textContent = noteText;
                
                            if (tool !== "") {
                                noteElement.style.display = "block";
                            } else {
                                noteElement.style.display = "none";
                            }
                        }
                    </script>
                </form>
            </div>
        </div>

    <!-- ---------------------------------- -->

    <div class="column">
        <div class="row readme-content" id="readme-content">                    
            <h2>Generated README content</h2>
            <form action="/readme" method="POST">
                <pre id="generated-readme" style="white-space: pre-wrap;">{{ readme_content | safe }}</pre>
                <img src="{{ url_for('static', filename='uml_name.png') }}" alt="UML Diagram" width="1500" height="200">
                <input type="submit" value="Show README">
            </form>
        </div>
        <div class="row form-box3">
            <h3>Rate This README</h3>
            <div class="rating">
                <input type="radio" id="star5" name="rating" value="5" onclick="rateReadme(1)">
                <label for="star1"></label>
                <textarea id="feedback1" name="feedback" style="display: none;"></textarea>
        
                <input type="radio" id="star4" name="rating" value="4" onclick="rateReadme(2)">
                <label for="star2"></label>
                <textarea id="feedback2" name="feedback" style="display: none;"></textarea>
        
                <input type="radio" id="star3" name="rating" value="3" onclick="rateReadme(3)">
                <label for="star3"></label>
                <textarea id="feedback3" name="feedback" style="display: none;"></textarea>
        
                <input type="radio" id="star2" name="rating" value="2" onclick="rateReadme(4)">
                <label for="star4"></label>
                <textarea id="feedback4" name="feedback" style="display: none;"></textarea>
        
                <input type="radio" id="star1" name="rating" value="1" onclick="rateReadme(5)">
                <label for="star5"></label>
                <textarea id="feedback5" name="feedback" style="display: none;"></textarea>
            </div>
        </div>
        
    </div>
</div>
</div>
</body>

<script>
    function rateReadme(rating) {
        // Show the corresponding textarea for the clicked star
        var feedbackTextarea = document.getElementById('feedback' + rating);
        feedbackTextarea.style.display = 'block';
        
        // Capture the user feedback
        var feedback = prompt("Please provide your feedback for this rating:");
        if (feedback !== null) {
            feedbackTextarea.value = feedback;
        } else {
            // If the user cancels the prompt, hide the textarea
            feedbackTextarea.style.display = 'none';
        }
        
        // Hide other textareas for stars with lower ratings
        for (var i = 1; i <= 5; i++) {
            if (i !== rating) {
                var otherTextarea = document.getElementById('feedback' + i);
                otherTextarea.style.display = 'none';
                otherTextarea.value = ''; // Clear previous feedback
            }
        }
        
        // Send the rating and feedback to the server
        var data = {
            "rating": rating,
            "feedback": feedback
        };
        
        fetch('/rate_readme', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
            },
            body: JSON.stringify(data),
        })
        .then(response => response.json())
        .then(data => {
            console.log('Success:', data);
            // Handle success if needed
        })
        .catch((error) => {
            console.error('Error:', error);
            // Handle error if needed
        });
    }
</script>


<script>
    function openInstructions() {
        // Define the content for the instructions window
        var instructionsContent = `
            <!DOCTYPE html>
            <html lang="en">
            <head>
                <meta charset="UTF-8">
                <meta http-equiv="X-UA-Compatible" content="IE=edge">
                <meta name="viewport" content="width=device-width, initial-scale=1.0">
                <title>README Generation Instructions</title>
                <style>
                    body {
                        font-family: 'Arial', sans-serif;
                        margin: 20px;
                        background-color: #f4f4f4;
                    }

                    .instructions {
                        padding: 20px;
                        border: 1px solid #ccc;
                        border-radius: 5px;
                        background-color: #fff;
                        margin-bottom: 20px;
                    }

                    .highlight {
                        font-weight: bold;
                        color: #3c7a3f; /* green color */
                    }
                </style>
            </head>
            <body>
                <div class="instructions">
                <p><strong>README.md Generation Instructions:</strong>
                    Please adhere to the following instructions to create a README.md file for the Graphene tutorial. 
                    <br><br>
                    The OpenAI-LLM-Selector lets users pick the OpenAI LLMs and other API parameters. If these parameters still need to be selected, please revisit this module, make the selections, and execute the pipeline ('Run' option).
                    The current pipeline is tested with the model - 'gpt-3.5-turbo-instruct'  and temp - 0.0
                    <br><br>
                    <span class="highlight">Clone Repository :</span> Select the desired tutorial and its respective repository URL and subdirectory path.
                    <br><br> For a sample reference, you can use the following link [https://gitlab.eclipse.org/eclipse/graphene/tutorials.git] as the 'Repository URL' and the tutorial's name in the 'Subdirectory Path.'
                    <br><br>
                    <span class="highlight">Protobuf Files Summarizer:</span> Customize the 'Protobuf Files Summarizer' prompt to generate the README introduction.
                    <br><br>
                    <span class="highlight">Agent Tooling:</span> Utilize the 'Agent Tooling' to generate additional sections of the README. Sample queries are provided for each tool.
                    <br><br>
                    <span class="highlight">Review and Feedback:</span> Once the README is generated to the satisfaction, evaluate its quality by providing the ratings and necessary feedback.
                </p>
            </div>
            </body>
            </html>
        `;
        
        // Open a new window with the instructions content
        var instructionsWindow = window.open("", "Instructions", "width=600,height=400");
        
        // Write the content to the new window
        instructionsWindow.document.write(instructionsContent);
    }
</script>

</html>